<!-- Any copyright is dedicated to the Public Domain.
     http://creativecommons.org/publicdomain/zero/1.0/ -->
<!doctype html>

<html>
  <head>
    <meta charset="utf-8"/>
    <meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="0" />
    <title>Network Monitor test page</title>
    <link rel="stylesheet" type="text/css" href="stylesheet_request" />
  </head>

  <body>
    <p>Request cause test</p>
    <img src="img_request" />
    <div style="height: 200vh;"></div>
    <img loading="lazy" src="lazy_img_request" />
    <script type="text/javascript">
      "use strict";

      function performXhrRequest() {
        const xhr = new XMLHttpRequest();
        xhr.open("GET", "xhr_request", true);
        return new Promise(function performXhrRequestCallback(resolve) {
          xhr.onload = resolve;
          xhr.send();
        });
      }

      function performFetchRequest() {
        return fetch("fetch_request");
      }

      // Perform some requests with async stacks
      function performPromiseFetchRequest() {
        return Promise.resolve().then(function performPromiseFetchRequestCallback() {
          return fetch("promise_fetch_request");
        });
      }

      function performTimeoutFetchRequest() {
        return new Promise(function performTimeoutFetchRequestCallback1(resolve) {
          setTimeout(function performTimeoutFetchRequestCallback2() {
            resolve(fetch("timeout_fetch_request"));
          }, 0);
        });
      }

      function performLazyLoadingImage() {
        return new Promise(function (resolve) {
          const lazyImg = document.querySelector("img[loading='lazy']");
          lazyImg.addEventListener("error", resolve);
          lazyImg.scrollIntoView({ behavior: "instant" });
        });
      }

      function performBeaconRequest() {
        navigator.sendBeacon("beacon_request");
      }

      (async function() {
        await performXhrRequest();
        await performFetchRequest();
        await performPromiseFetchRequest();
        await performTimeoutFetchRequest();
        await performLazyLoadingImage();

        // Finally, send a beacon request
        performBeaconRequest();
      })();
    </script>
  </body>
</html>
